# Support and Subscription

Pigsty is a battery-included use PostgreSQL database distribution, a local-first alternative to RDS/cloud database services, allowing users to run a fully-featured local RDS service at a hardware cost of just a few core months. The software itself is completely open-source and free. If it has helped you, please consider [sponsoring us](#sponsorship).

Although Pigsty is designed to replace manual database operations with database autopilot software, even the best software can only solve some problems. There will always be some infrequent issues and various problems not limited to technology that require expert intervention. Therefore, we also offer professional [service subscriptions](#service-subscription).


------------------

## Sponsorship

Pigsty is a free & open-source software nurtured by the passion of PostgreSQL community members.

If our work has helped you, please consider sponsoring or supporting our project. Every penny counts, and advertisements are also a form of support:

- Make Donation & Sponsor us.
- Share your experiences and use cases of Pigsty through articles, lectures, and videos.
- Allow us to mention your organization in "These users who use Pigsty"
- Nominate/Recommend our project and services to your friends, colleagues, and clients in need.
- Follow our [WeChat Column](https://mp.weixin.qq.com/s/-E_-HZ7LvOze5lmzy3QbQA) and share technical articles with your friends.

The Pigsty community already offers free WeChat/Discord/Telegram Q&A Office Hours, and we are also happy to provide more free value-added services to our supporters.

We have a GPTs for Pigsty documentation QA: https://chat.openai.com/g/g-y0USNfoXJ-pigsty-consul

WeChat: Search `pigsty-cc` and join the User Group.

Telegram: https://t.me/joinchat/gV9zfZraNPM3YjFh

Discord: https://discord.gg/D92HzV2s


------------------

## Service Subscription

|    Plan    |                  Open Source                  |                                      Basic                                       |                                                 Pro                                                  |                                                                     Enterprise                                                                     |
|:----------:|:---------------------------------------------:|:--------------------------------------------------------------------------------:|:----------------------------------------------------------------------------------------------------:|:--------------------------------------------------------------------------------------------------------------------------------------------------:|
|    Who     |     Self-sufficient OSS Guru, Developers      |                   Elite tech team who seeks additional support                   |                                   suitable choice for common users                                   |                                                    critical scenarios that require strict SLAs                                                     |
|   Price    |           **Free** under **AGPLv3**           |                                **7,000** $ / Year                                |                                         **20,000** $ / Year                                          |                                                                **50,000** $ / Year                                                                 |
| Node Size  |                 **Unlimited**                 |                                     **<= 5**                                     |                                              **<= 15**                                               |                                                                     **<= 40**                                                                      |
|  Consult   | Community Support<br />Groups, Issues, Discuz |           **Bug Fix & Security Patch**<br />**Failure Analysis**<br />           | **Bug Fix & Security Patch**<br />**Failure Analysis**<br />**Upgrade Path**<br />**DBA Consulting** | **Bug Fix & Security Patch**<br />**Failure Analysis**<br />**Upgrade Path**<br />**DBA Consulting**<br />**Arch Review**<br />**Failure on-call** |
|  Service   |                       -                       |                           One-time setup (< 1 workday)                           |                                       Two free workdays / Year                                       |                                                             Four free workdays / Year                                                              |
|  Product   |                  Pigsty OSS                   |                                  Pigsty **PRO**                                  |                                            Pigsty **PRO**                                            |                                                                   Pigsty **PRO**                                                                   |
| PG Support |           Last 1 version<br />PG 16           |                      Last **2** version<br />PG **15**, 16                       |                                Lifecycle version<br />PG **12** - 16                                 |                                                     15 Version Since 9.0<br />PG **9.0** - 16                                                      |
| OS Support |        EL 8.9 / 9.3<br />Ubuntu 22.04         | EL 7.9 / **8.x** / **9.x**<br />Ubuntu 22.04 / **20.04**<br />**Debian 11 / 12** |           EL 7.9 / **8.x** / **9.x**<br />Ubuntu 22.04 / **20.04**<br />**Debian 11 / 12**           |                   EL **7.x** / **8.x** / **9.x**<br />**Ubuntu / Debian LTS**<br /> **UOS v20 / Anolis 8.8** <br />**Be spoke**                    |
|    Arch    |                    x86_64                     |                                      x86_64                                      |                                                x86_64                                                |                                                              x86_64<br />**ARM64** ❋                                                               |
|    SLA     |                       -                       |                                      < 48h                                       |                                              **5 x 8**                                               |                                                                     **7 x 24**                                                                     |
| Cost Like  |      Compare to <br />**RDS** & **DBA**       |                     **12** vCPU RDS<br />Part-Time Operators                     |                               **40** vCPU RDS<br />**??%** Junior DBA                                |                                                         **100** vCPU RDS<br />**??%** DBA                                                          |


Pigsty Pro offers an expanded range of features, supporting a wider variety of operating system distributions, PostgreSQL major versions, and a richer set of extension plugins. It also includes offline software packages tailored for each OS minor version to ensure optimal compatibility.

Pigsty subscriptions operate on an annual payment model, providing users with an annual license for the Pigsty commercial version. 
This includes access to the latest software versions and upgrade paths released within the year, along with comprehensive consulting, Q&A, and service support. 
A larger scale implies more complex scenarios, more issues, and a higher chance of failure events: thus, each subscription comes with a node scale limit. 
For example, if you are using the Pro subscription and manage 15 nodes, you will need to pay an additional subscription fee for each node beyond the limit (10,000 RMB per node).

Pigsty's pricing strategy ensures value for money — you can immediately obtain top-notch DBA database architecture solutions and management best practices, all backed by consulting, Q&A, and service support, at a cost that is highly competitive compared to find-out & hiring rare database Guru or using cloud RDS.

If you have the following needs, please consider our **subscription**:

- Running databases in critical scenarios and needing strict SLA guarantees.
- Seeking backup for Pigsty and PostgreSQL-related issues.
- Wanting guidance on best practices for PostgreSQL/Pigsty production environments.
- Needing experts to help interpret monitoring charts, analyze and locate performance bottlenecks and fault root causes, and provide opinions.
- Planning a database architecture that meets security, disaster recovery, and compliance requirements based on existing resources and business needs.
- Needing to migrate other databases to PostgreSQL, or migrate and transform legacy instances.
- Building an observability system, data dashboard, and visualization application based on the Prometheus/Grafana tech stack.
- Seeking support for domestic trusted operating systems/domestic trusted ARM chip architectures and providing Chinese/localized interface support.
- Moving off the cloud and seeking an open-source alternative to RDS for PostgreSQL - a cloud-neutral, vendor-lock-in-free solution.
- Seeking professional technical support for Redis/ETCD/MinIO/Greenplum/Citus/TimescaleDB.
- Wanting to avoid the restrictions of the AGPLv3 license of Pigsty itself, doing derivative works being forced to use the same open-source license for secondary development and branding.
- Consider selling Pigsty as SaaS/PaaS/DBaaS or providing technical services/consulting services based on this distribution.

Service subscriptions are divided into two different levels, **Standard Service Agreement,** and **Enterprise Service Agreement**, as shown in the table below:


Commercial support contact: Email: [rh@vonng.com](mailto:rh@vonng.com), WeChat: pigsty-cc / RuohangFeng


------------------

## Miscellaneous

We offer retail expert days that can be used for database architecting, failure analysis, postmortem, troubleshooting, performance analysis, problem-solving, teaching, and training, which can be purchased as needed.

- Top Expert: 3,000 $ / day
- Senior Expert: 2,000 ¥ / day

The above prices are exclusive of taxes. The minimum unit is half a day, less than that will be charged as half a day.
Price is doubled outside regular working hours (5x8), and it's tripled on public holidays.
Pricing & Discount may vary depending on the industry and the technical level of the client's team.

Expert days need to be arranged at least one day before. 
Emergency failure responding is not applicable here and only available to subscribed customers.

We offer teaching and training services on PostgreSQL, priced as follows:

- PostgreSQL Application Development: 1 x expert day, up to 20 people.
- PostgreSQL Management & Operation: 1 x expert day, up to 20 people.
- PostgreSQL Kernel Architecture: 2 x expert day, up to 10 people.

We offer deployment consulting and architecting services, priced as follows:

- Planning a deployment solution based on your existing resources and needs.
- 150 $/h, at least one hour per case, remote only. Delivery includes the `pigsty.yml` file. 
